3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
49 if test "$1" = "#unmatched"
56 # Print a submodule configuration setting
62 # Checks in the usual git-config places first (for overrides),
63 # otherwise it falls back on .gitmodules. This allows you to
64 # distribute project-wide defaults in .gitmodules, while still
65 # customizing individual repositories if necessary. If the option is
66 # not in .gitmodules either, print a default value.
68 get_submodule_config () {
72 value=$(git config submodule."$name"."$option")
75 value=$(git config -f .gitmodules submodule."$name"."$option")
77 printf '%s' "${value:-$default}"
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
85 # Sanitize the local git environment for use within a submodule. We
86 # can't simply use clear_local_git_env since we want to preserve some
87 # of the settings from GIT_CONFIG_PARAMETERS.
88 sanitize_submodule_env()
90 save_config=$GIT_CONFIG_PARAMETERS
92 GIT_CONFIG_PARAMETERS=$save_config
93 export GIT_CONFIG_PARAMETERS
97 # Add a new submodule to the working tree, .gitmodules and the index
101 # optional branch is stored in global branch variable
105 # parse $args after "submodule ... add".
111 case "$2" in '') usage ;; esac
125 case "$2" in '') usage ;; esac
130 reference_path="${1#--reference=}"
136 case "$2" in '') usage ;; esac
141 case "$2" in '') usage ;; esac
162 if test -n "$reference_path"
164 is_absolute_path "$reference_path" ||
165 reference_path="$wt_prefix$reference_path"
167 reference="--reference=$reference_path"
173 if test -z "$sm_path"; then
174 sm_path=$(printf '%s\n' "$repo" |
175 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
178 if test -z "$repo" || test -z "$sm_path"; then
182 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
184 # assure repo is absolute or relative to parent
187 test -z "$wt_prefix" ||
188 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
190 # dereference source url relative to parent's url
191 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
198 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
203 # multiple //; leading ./; /./; /../; trailing /
204 sm_path=$(printf '%s/\n' "$sm_path" |
216 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
217 die "$(eval_gettext "'\$sm_path' already exists in the index")"
219 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
220 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
223 if test -z "$force" &&
224 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
226 eval_gettextln "The following path is ignored by one of your .gitignore files:
228 Use -f if you really want to add it." >&2
232 if test -n "$custom_name"
234 sm_name="$custom_name"
239 if ! git submodule--helper check-name "$sm_name"
241 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
244 # perhaps the path exists and is already a git repo, else clone it
245 if test -e "$sm_path"
247 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
249 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
251 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
255 if test -d ".git/modules/$sm_name"
259 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
260 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
261 die "$(eval_gettextln "\
262 If you want to reuse this local git directory instead of cloning again from
264 use the '--force' option. If the local git directory is not the correct repo
265 or you are unsure what this means choose another name with the '--name' option.")"
267 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
270 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
272 sanitize_submodule_env
274 # ash fails to wordsplit ${branch:+-b "$branch"...}
276 '') git checkout -f -q ;;
277 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
279 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
281 git config submodule."$sm_name".url "$realrepo"
283 git add --no-warn-embedded-repo $force "$sm_path" ||
284 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
286 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
287 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
290 git config -f .gitmodules submodule."$sm_name".branch "$branch"
292 git add --force .gitmodules ||
293 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
295 # NEEDSWORK: In a multi-working-tree world, this needs to be
296 # set in the per-worktree config.
297 if git config --get submodule.active >/dev/null
299 # If the submodule being adding isn't already covered by the
300 # current configured pathspec, set the submodule's active flag
301 if ! git submodule--helper is-active "$sm_path"
303 git config submodule."$sm_name".active "true"
306 git config submodule."$sm_name".active "true"
311 # Execute an arbitrary command sequence in each checked out
314 # $@ = command to execute
318 # parse $args after "submodule ... foreach".
338 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
342 # Register submodules in .git/config
344 # $@ = requested paths (default to all)
348 # parse $args after "submodule ... init".
369 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
373 # Unregister submodules from .git/config and remove their work tree
377 # parse $args after "submodule ... deinit".
405 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
408 is_tip_reachable () (
409 sanitize_submodule_env &&
411 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
415 fetch_in_submodule () (
416 sanitize_submodule_env &&
423 git fetch $(get_default_remote) "$@" ;;
428 # Update each submodule path to correct revision, using clone and checkout as needed
430 # $@ = requested paths (default to all)
434 # parse $args after "submodule ... update".
463 case "$2" in '') usage ;; esac
464 reference="--reference=$2"
483 recommend_shallow="--recommend-shallow"
485 --no-recommend-shallow)
486 recommend_shallow="--no-recommend-shallow"
489 case "$2" in '') usage ;; esac
497 case "$2" in '') usage ;; esac
520 cmd_init "--" "$@" || return
524 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
525 ${progress:+"--progress"} \
526 ${wt_prefix:+--prefix "$wt_prefix"} \
527 ${prefix:+--recursive-prefix "$prefix"} \
528 ${update:+--update "$update"} \
529 ${reference:+"$reference"} \
530 ${dissociate:+"--dissociate"} \
531 ${depth:+--depth "$depth"} \
534 "$@" || echo "#unmatched" $?
537 while read -r quickabort sha1 just_cloned sm_path
539 die_if_unmatched "$quickabort" "$sha1"
541 git submodule--helper ensure-core-worktree "$sm_path"
543 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
545 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
547 if test $just_cloned -eq 1
551 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
552 git rev-parse --verify HEAD) ||
553 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
558 branch=$(git submodule--helper remote-branch "$sm_path")
559 if test -z "$nofetch"
561 # Fetch remote before determining tracking $sha1
562 fetch_in_submodule "$sm_path" $depth ||
563 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
565 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
566 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
567 git rev-parse --verify "${remote_name}/${branch}") ||
568 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
571 if test "$subsha1" != "$sha1" || test -n "$force"
574 # If we don't already have a -f flag and the submodule has never been checked out
575 if test -z "$subsha1" && test -z "$force"
580 if test -z "$nofetch"
582 # Run fetch only if $sha1 isn't present or it
583 # is not reachable from a ref.
584 is_tip_reachable "$sm_path" "$sha1" ||
585 fetch_in_submodule "$sm_path" $depth ||
586 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
588 # Now we tried the usual fetch, but $sha1 may
589 # not be reachable from any of the refs
590 is_tip_reachable "$sm_path" "$sha1" ||
591 fetch_in_submodule "$sm_path" $depth "$sha1" ||
592 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
596 case "$update_module" in
598 command="git checkout $subforce -q"
599 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
600 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
604 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
605 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
606 must_die_on_failure=yes
610 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
611 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
612 must_die_on_failure=yes
615 command="${update_module#!}"
616 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
617 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
618 must_die_on_failure=yes
621 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
624 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
627 elif test -n "$must_die_on_failure"
629 die_with_status 2 "$die_msg"
631 err="${err};$die_msg"
636 if test -n "$recursive"
639 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
641 sanitize_submodule_env
648 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
651 err="${err};$die_msg"
654 die_with_status $res "$die_msg"
678 # Show commit summary for submodules in index or working tree
680 # If '--cached' is given, show summary between index and given commit,
681 # or between working tree and given commit
683 # $@ = [commit (default 'HEAD'),] requested paths (default all)
690 # parse $args after "submodule ... summary".
705 isnumber "$summary_limit" || usage
709 summary_limit="${1#--summary-limit=}"
710 isnumber "$summary_limit" || usage
726 test $summary_limit = 0 && return
728 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
732 elif test -z "$1" || test "$1" = "HEAD"
734 # before the first commit: compare with an empty tree
735 head=$(git hash-object -w -t tree --stdin </dev/null)
736 test -z "$1" || shift
744 die "$(gettext "The --cached option cannot be used with the --files option")"
750 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
751 # Get modified modules cared by user
752 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
753 sane_egrep '^:([0-7]* )?160000' |
754 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
756 # Always show modules deleted or type-changed (blob<->module)
757 if test "$status" = D || test "$status" = T
759 printf '%s\n' "$sm_path"
762 # Respect the ignore setting for --for-status.
763 if test -n "$for_status"
765 name=$(git submodule--helper name "$sm_path")
766 ignore_config=$(get_submodule_config "$name" ignore none)
767 test $status != A && test $ignore_config = all && continue
769 # Also show added or modified modules which are checked out
770 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
771 printf '%s\n' "$sm_path"
775 test -z "$modules" && return
777 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
778 sane_egrep '^:([0-7]* )?160000' |
780 while read -r mod_src mod_dst sha1_src sha1_dst status name
782 if test -z "$cached" &&
783 test $sha1_dst = 0000000000000000000000000000000000000000
787 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
789 100644 | 100755 | 120000)
790 sha1_dst=$(git hash-object $name)
796 eval_gettextln "unexpected mode \$mod_dst" >&2
803 test $mod_src = 160000 &&
804 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
807 test $mod_dst = 160000 &&
808 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
811 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
814 case "$missing_src,$missing_dst" in
816 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
819 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
822 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
827 if test $mod_src = 160000 && test $mod_dst = 160000
829 range="$sha1_src...$sha1_dst"
830 elif test $mod_src = 160000
836 GIT_DIR="$name/.git" \
837 git rev-list --first-parent $range -- | wc -l
839 total_commits=" ($(($total_commits + 0)))"
843 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
844 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
847 blob="$(gettext "blob")"
848 submodule="$(gettext "submodule")"
849 if test $mod_dst = 160000
851 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
853 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
856 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
860 # Don't give error msg for modification whose dst is not submodule
861 # i.e. deleted or changed to blob
862 test $mod_dst = 160000 && echo "$errmsg"
864 if test $mod_src = 160000 && test $mod_dst = 160000
867 test $summary_limit -gt 0 && limit="-$summary_limit"
868 GIT_DIR="$name/.git" \
869 git log $limit --pretty='format: %m %s' \
870 --first-parent $sha1_src...$sha1_dst
871 elif test $mod_dst = 160000
873 GIT_DIR="$name/.git" \
874 git log --pretty='format: > %s' -1 $sha1_dst
876 GIT_DIR="$name/.git" \
877 git log --pretty='format: < %s' -1 $sha1_src
885 # List all submodules, prefixed with:
886 # - submodule not initialized
887 # + different revision checked out
889 # If --cached was specified the revision in the index will be printed
890 # instead of the currently checked out revision.
892 # $@ = requested paths (default to all)
896 # parse $args after "submodule ... status".
923 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
926 # Sync remote urls for submodules
927 # This makes the value for remote.$remote.url match the value
928 # specified in .gitmodules.
956 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
961 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
964 # This loop parses the command line arguments to find the
965 # subcommand name to dispatch. Parsing of the subcommand specific
966 # options are primarily done by the subcommand implementations.
967 # Subcommand specific options such as --branch and --cached are
968 # parsed here as well, for backward compatibility.
970 while test $# != 0 && test -z "$command"
973 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1003 # No command word defaults to "status"
1004 if test -z "$command"
1014 # "-b branch" is accepted only by "add"
1015 if test -n "$branch" && test "$command" != add
1020 # "--cached" is accepted only by "status" and "summary"
1021 if test -n "$cached" && test "$command" != status && test "$command" != summary